version: "3.9"

services:
  app: &app
    image: registry.gitlab.inria.fr/scripta/escriptorium/app
    build:
      context: .
    env_file: variables.env
    volumes:
      # - ./app/:/usr/src/app/
      - static:/usr/src/app/static
      - media:/usr/src/app/media
    depends_on:
      - db
      - redis
    command: /bin/true

  web:
    <<: *app
    command: uwsgi --ini /usr/src/app/uwsgi.ini

  channelserver:
    <<: *app
    command: daphne --bind 0.0.0.0 --port 5000 -v 1 escriptorium.asgi:application
    expose:
      - 5000
    depends_on:
      - web

  db:
    image: postgres:10.5-alpine
    volumes:
      - postgres:/var/lib/postgresql/data/
    env_file: variables.env

  redis:
    image: redis:3.0-alpine

  nginx:
    image: registry.gitlab.inria.fr/scripta/escriptorium/nginx
    build: ./nginx
    environment:
      - SERVERNAME=${DOMAIN:-localhost}
    volumes:
      - static:/usr/src/app/static
      - media:/usr/src/app/media
    ports:
      - 8080:80
    depends_on:
      - web
      - channelserver

  # elasticsearch:
  #   image: docker.elastic.co/elasticsearch/elasticsearch:6.5.1
  #   environment:
  #     - cluster.name=docker-cluster
  #     - bootstrap.memory_lock=true
  #     - "ES_JAVA_OPTS=-Xms512m -Xmx512m"
  #   ulimits:
  #     memlock:
  #       soft: -1
  #       hard: -1
  #   volumes:
  #     - ./esdata/:/usr/share/elasticsearch/data
  #   #expose:
  #   #   - 9200
  #   # ports:
  #   #  - 9200:9200
  #   # networks:  # use this if adding nodes
  #   #   - esnet

  celery-main:
    <<: *app
    command: "celery worker -l INFO -E -A escriptorium -Ofair --prefetch-multiplier 1 -Q default -c ${CELERY_MAIN_CONC:-10} --max-tasks-per-child=10"
    depends_on:
      - web

  celery-low-priority:
    <<: *app
    command: "celery worker -l INFO -E -A escriptorium -Ofair --prefetch-multiplier 1 -Q low-priority -c ${CELERY_LOW_CONC:-10} --max-tasks-per-child=10"
    depends_on:
      - web

  celery-gpu: &celery-gpu
    <<: *app
    environment:
      - KRAKEN_TRAINING_DEVICE=cpu
    command: "celery worker -l INFO -E -A escriptorium -Ofair --prefetch-multiplier 1 -Q gpu -c 1 --max-tasks-per-child=1"
    shm_size: '3gb'
    depends_on:
      - web

  flower:
    image: mher/flower
    command: ["flower", "--broker=redis://redis:6379/0", "--port=5555"]
    ports:
      - 5555:5555
    depends_on:
      - redis

  # No need while we don't have regular tasks
  # celerybeat:
  #   build:
  #     context: ./app
  #   env_file: variables.env
  #   depends_on:
  #     - db
  #     - redis
  #   volumes:
  #     - ./static/:/usr/src/app/static
  #     - ./media/:/usr/src/app/media
  #     - static:./static/
  #     - media:./media/
  #   command: celery -E -A escriptorium beat -l INFO

  mail:
    build: ./exim
    expose:
      - 25
    environment:
      - PRIMARY_HOST=${DOMAIN:-localhost}
      - ALLOWED_HOSTS=web ; celery-main ; celery-low-priority; docker0

volumes:
   static:
   media:
   postgres:
   esdata:
